<?php

/**
 * @file
 * Context.IO Feeds Plugins specific theme functions.
 */

/**
 * Theme function for message parser plugin's derivative sources tables.
 *
 * @see ContextIOMessageParser::configForm()
 */
function theme_contextio_feeds_plugins_message_parser_derivative_sources_table($variables) {
  $element = $variables['element'];

  $table = array(
    '#theme' => 'table',
    '#header' => $element['#header'],
    '#rows' => array(),
    '#attributes' => $element['#attributes'],
    '#caption' => $element['#caption'],
    '#colgroups' => $element['#colgroups'],
    '#sticky' => $element['#sticky'],
    '#empty' => $element['#empty'],
  );

  foreach (element_children($element) as $item_index) {
    $row = array('data' => array());
    foreach (element_children($element[$item_index]) as $col_name) {
      $col_props = array_keys($element[$item_index][$col_name]);
      if (in_array('data', $col_props) || in_array('class', $col_props)) {
        if (isset($element[$item_index][$col_name]['data'])) {
          $row['data'][] = array(
            'data' => drupal_render($element[$item_index][$col_name]['data']),
          );
          if (isset($element[$item_index][$col_name]['class'])) {
            $row['data'][count($row['data']) - 1]['class'] = $element[$item_index][$col_name]['class']['#value'];
          }
        }
      }
      else {
        $row['data'][] = drupal_render($element[$item_index][$col_name]);
      }
    }
    $table['#rows'][] = $row;
  }

  return drupal_render($table);
}
